clear,clc;
WPO=[55.7 0.3	9.2	5.2	0.1	1.4	2.4	8.7	0.0	2.0	0.1	3.0];
[Anh,xH2O] = Anh_xH2O(WPO);
[fname,pathname,filterindex]=uigetfile('*.xlsx','ѡļ');


workspace='sheet5';
[data,text,alldata]=xlsread(fname,workspace);

[m,n]=size(data'); %%%%m point number
n=n-1;

pointname=text(1,2:end);

elementname=text(2:end,1);

data1=data(1:15,:);
data2=data(17:19,:);
data3=data(3,:);
data4=data(20:21,:);
dataall=[data1;data2;data3;data4];

aSi02=1.00;
aTi02=0.6;
r03=0.93;
r04=0.84;%%%%%%%%%%%%%input%%%%%%%%%

IR=[1.019
1.160
1.143
1.126
1.109
1.079
1.066
1.053
1.040
1.027
1.015
1.004
0.994
0.985
0.977
0.74
0.84
0.83
0.970
1.050
1.000
]';  %%%const%%%%%
rrcom=(IR/3.0+r03/6).*(IR-r03).^2;
rrcom(16:end)=(IR(16:end)/3.0+r04/6).*(IR(16:end)-r04).^2;


ConM=[10.3
18.05
36.34
3.96
14.44
2.68
0.67
2.54
0.4
2.15
0.38
0.99
0.14
0.9
0.14
2037
150
4.4
36.34
6.1
4.1
]';
j=1;


filename='outputdata.xls';
sheet=1;
xlRange='B2';
xlswrite(filename,pointname,sheet,xlRange);
 xlRange='A3';
 xlswrite(filename,elementname,sheet,xlRange);

% 
for i=1:m;
%  for i=1;
 ConZ=dataall(:,i)';
% ConZ=[523
% 0.43
% 3.83
% 0.59
% 5.29
% 6.50
% 2.43
% 22.36
% 6.79
% 61.14
% 16.65
% 55.64
% 9.47
% 72
% 12.86
% 871.12
% 309867
% 10407
% 3.83
% 66
% 3051
% ]';
Dzm=ConZ./ConM;
lgDzm=log10(Dzm);


IR2=[IR(8:15),IR(end-3),IR(end-1:end)]';
rrcom2=(IR2/3.0+r03/6).*(IR2-r03).^2;
rrcom2(9:end)=(IR2(9:end)/3.0+r04/6).*(IR2(9:end)-r04).^2;

ConM2=[ConM(8:15),ConM(end-3),ConM(end-1:end)]';
ConZ2=[ConZ(8:15),ConZ(end-3),ConZ(end-1:end)]';
Dzm2=ConZ2./ConM2;
lgDzm2=log10(Dzm2);

p3Cat=polyfit(rrcom2(1:8),lgDzm2(1:8),1);
hh=figure(i);


datacom1=[rrcom(1:14)',lgDzm(1:14)'];
sd1=sortrows(datacom1);

datacom2=[rrcom(17:21)',lgDzm(17:21)'];
sd2=sortrows(datacom2);

set(gcf,'unit','normalized','position',[0.4 0.6 0.6 0.3])
subplot(1,2,1)
plot(sd1(:,1),sd1(:,2),'ro-',rrcom(1:14),polyval(p3Cat,rrcom(1:14)));
 set(gca,'position',[0.1 0.3 0.4 0.4])
%  ylim([0,4])

p4Cat=polyfit(rrcom2(9:11),lgDzm2(9:11),1);
subplot(1,2,2)
plot(sd2(:,1),sd2(:,2),'or-',rrcom(17:21),polyval(p4Cat,rrcom(17:21)));
hold on;
set(gca,'position',[0.5 0.3 0.4 0.4])
%  ylim([0,4])
 titlename=cell2mat(pointname(i))
print(gcf,'-dtiff',titlename)

lgDzmpolyfit1=rrcom(1:15)*p3Cat(1)+p3Cat(2);
lgDzmpolyfit2=rrcom(16:21)*p4Cat(1)+p4Cat(2);
lgDzmpolyfit=[lgDzmpolyfit1,lgDzmpolyfit2];
Dzmpolyfit=10.^(lgDzmpolyfit);

% Anh=0.508;
% xH2O=0.109;

T=1.0/(log10(ConZ(16))-5.711+log10(aSi02)-log10(aTi02))*(-4800.0);
TK(i)=T;
DCe=Dzm(3);

h9=DCe;
n9=Dzmpolyfit(3);
n26=Dzmpolyfit(19);
Ce4Ce3=(h9-n9)/(n26-h9)/(1-(h9-n9)/(n26-h9));
logfO2=4*(log(1.0487*Ce4Ce3)-13136/T+2.064*Anh+xH2O*8.878+8.9554)/2.30259;
DFMQ=logfO2-(-587474+1584.427*T-203.3164*T*log(T)+0.09271*T^2)/(8.3145101*T*log(10));

if((isreal(logfO2))&&(isreal(DFMQ)))
    
%     LOGDF(j)=logfO2;
%     DFMQDATA(j)=DFMQ;
%     j=j+1;
    LOGDF(i)=logfO2;
    DFMQDATA(i)=DFMQ; 
else
     LOGDF(i)=-5;
     DFMQDATA(i)=-5;
end


if(i<26)
xlR=char(65+i);
xlRange2=strcat(xlR,'3');
xlswrite(filename,lgDzm(1:15)',sheet,xlRange2);
xlRange2=strcat(xlR,'19');
xlswrite(filename,[lgDzm(16:18)';lgDzm(20:21)'],sheet,xlRange2);
else
    xlR=char(65+i-26);
xlRange2=strcat('A',xlR,'3');
xlswrite(filename,lgDzm(1:15)',sheet,xlRange2);
xlRange2=strcat('A',xlR,'19');
xlswrite(filename,[lgDzm(16:18)';lgDzm(20:21)'],sheet,xlRange2);
end

  close all;
end
xlRange3='A24';
abs={'logfO2'};
xlswrite(filename,abs,sheet,xlRange3);
xlRange4='B24';
xlswrite(filename,LOGDF,sheet,xlRange4);

xlRange3='A25';
abs={'DFMQ'};
xlswrite(filename,abs,sheet,xlRange3);
xlRange4='B25';
xlswrite(filename,DFMQDATA,sheet,xlRange4);

xlRange3='A26';
abs={'T'};
xlswrite(filename,abs,sheet,xlRange3);

xlRange3='B26';
xlswrite(filename,TK,sheet,xlRange3);

% 

